#ifndef SOLVER_H_
#define SOLVER_H_


////////////////////////////////////////////////////////////////////////////////
//                                  Include                                   //
////////////////////////////////////////////////////////////////////////////////


#include "Oracle.h"
#include "QPBundle.h"


////////////////////////////////////////////////////////////////////////////////
//                                 Namespace                                  //
////////////////////////////////////////////////////////////////////////////////


namespace Bundle_di_unipi_it {


////////////////////////////////////////////////////////////////////////////////
//                                   Class                                    //
////////////////////////////////////////////////////////////////////////////////


class Solver : public QPBundle
{
private: //----- Private -------------------------------------------------------

  Oracle *oracle;   // Pointer to an Oracle
  double *uVector;  // Vector of multipliers
  double **xMatrix; // Matrix of x
  Index xPos;       // Position of new x in Bundle
  Index uSize;      // Size of u
  SgRow SG;         // Subgradient

protected: //----- Protected ---------------------------------------------------

  HpNum Fi(cLMRow Lam1, cIndex_Set LamB, Index LamBd);

  void SetGi(SgRow SubG, cIndex Name);

  SIndex GetGi(HpNum &Eps1, cIndex_Set &SGBse);

  #if(DO_AGGR)
  void AggrPrimalSol(cHpRow Mlt, cIndex_Set NmSt, cIndex Dm, cIndex NwNm )
  {
    // The method must be defined, but it can just do nothing
  }
  #endif

public: //----- Public ---------------------------------------------------------

  Solver(istream *param, Oracle *aOracle, cIndex uDimSize,
	     double **xMatrix);
    // param:    Parameters from the file ParValue
    // aOracle:  Pointer to an Oracle
    // uDimSize: u dimension size

  ~Solver();

}; // end(Solver)


////////////////////////////////////////////////////////////////////////////////


}; // end(Bundle_di_unipi_it)


////////////////////////////////////////////////////////////////////////////////


#endif
